Attribute VB_Name = "modSupport"
Option Explicit
' ********************************************************************************                                                                             *
' *                                                                              *
' *  modSupport.bas - core.exe this module contains support functions            *
' *                                                                              *
' *  Copyright (c) 2000-2001 Asperon (asperon@home.se), last updated 2001-05-31  *
' *                                                                              *
' *  This program is free software; you can redistribute it and/or modify        *
' *  it under the terms of the GNU General Public License as published by        *
' *  the Free Software Foundation; either version 2 of the License, or           *
' *  any later version.                                                          *
' *                                                                              *
' *  This program is distributed in the hope that it will be useful,             *
' *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
' *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
' *  GNU General Public License for more details.                                *
' *                                                                              *
' *  You should have received a copy of the GNU General Public License           *
' *  along with this program; if not, write to the Free Software                 *
' *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
' *                                                                              *
' ********************************************************************************

Public oServer As core.CServer
Public oSettings As core.ISettings

Public Desktop As Long

Dim lSave As Long

Public Log() As String

Public Type syscolor
    Name As String
    Value As Integer
End Type
Public SysColors() As syscolor

Public syscolor() As Long
Public ColorValues() As Long
Public OldColor() As Long

Public Type Plugin
    Name As String
    oPlugin As IBasePlugin
    hwnd As Long
End Type
Public Plugins() As Plugin

Private Type Bang
    Name As String
    provider As String
End Type
Public Bangs() As Bang

Public Type Info
    CompanyName As String
    FileDescription As String
    LegalCopyright As String
    ProductName As String
    FileVersion As String
    ProductVersion As String
    InternalName As String
    OriginalFilename As String
End Type
Public Function noPath(ByVal wPath As String) As String

    While InStr(wPath, "\")
        wPath = right(wPath, Len(wPath) - InStr(wPath, "\"))
    Wend
    noPath = wPath

End Function
Public Function path(ByVal wPath As String) As String

    path = left(wPath, Len(wPath) - Len(noPath(wPath)))

End Function
Public Function fGetSystemFolderPath(ByVal hwnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(hwnd, Id, lPidl)       ' Get lPidl for Id...
    If lReturn = 0 Then                                         ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)             ' Get Path from Item Id List
        If lReturn = 1 Then                                     ' If success is 1
            sPath = Trim$(sPath)                                ' Fix path string
            lPath = Len(sPath)                                  ' Get length of path
            If Asc(right$(sPath, 1)) = 0 Then lPath = lPath - 1 ' Adjust path length
            If lPath > 0 Then sfPath = left$(sPath, lPath)      ' Adjust path string variable
            fGetSystemFolderPath = True                         ' Return success
        End If
    End If

End Function
Public Sub RunFile(ByVal File As String, FilePath As String, RunStyle As Long)
    
    Dim Temp As String
    Dim MSG As String
    Dim ret As Long
    
    On Error Resume Next
    Temp = GetActiveWindow()
    ret = ShellExecute(Temp, "Open", File, "", FilePath, RunStyle)

    If ret < 32 Then

        Select Case ret
            Case 0
            MSG = "The file could Not be run due To insufficient system memory or a corrupt program file"
            Case 2
            MSG = "File Not Found"
            Case 3
            MSG = "Invalid Path"
            Case 5
            MSG = "Sharing or protection error"
            Case 6
            MSG = "Separate data segments are required For Each task "
            Case 8
            MSG = "Insufficient memory To run the program"
            Case 10
            MSG = "Incorrect Windows version"
            Case 11
            MSG = "Invalid Program File"
            Case 12
            MSG = "Program file requires a different operating System "
            Case 13
            MSG = "Program requires MS-DOS 4.0"
            Case 14
            MSG = "Unknown program file type"
            Case 15
            MSG = "Windows prgram does Not support protected memory mode"
            Case 16
            MSG = "Invalid use of data segments when loading a second instance of a program"
            Case 19
            MSG = "Attempt To run a compressed program file"
            Case 20
            MSG = "Invalid dynamic link library"
            Case 21
            MSG = "Program requires Windows 32-bit extensions"
            Case 31
            MSG = "No application found For this file"
        End Select
        oServer.Execute "!log error, " & MSG
    End If

End Sub
Public Sub runCommand(textline As String)

    Dim I As Long
    Dim j As Long
    Dim command As String
    Dim parameter As String
    Dim oPlugin As core.IBasePlugin
    Dim found As Boolean
    Dim syscolor(0) As Long
    Dim colorValue(0) As Long
    Dim ret As Long
    Dim sec As String
    Dim key As String
    Dim val As String
    
    If InStr(textline, " ") Then
        command = left(textline, InStr(textline, " ") - 1)
        parameter = right(textline, Len(textline) - InStr(textline, " "))
    Else
        parameter = ""
        command = textline
    End If
    
    Select Case LCase(command)
    Case "!setkey"
        'The user wants to write to the settings, lets do it!
        If InStr(parameter, " ") Then
            sec = left(parameter, InStr(parameter, " ") - 1)
            parameter = right(parameter, Len(parameter) - InStr(parameter, " "))
            If InStr(parameter, " ") Then
                key = left(parameter, InStr(parameter, " ") - 1)
                val = right(parameter, Len(parameter) - InStr(parameter, " "))
                oServer.SetKey sec, key, val
            Else
                oServer.Execute "!log sytax error, the correct sytax is !setkey [section] [key] [value]"
            End If
        Else
            oServer.Execute "!log sytax error, the correct sytax is !setkey [section] [key] [value]"
        End If
    Case "!shutdown"
        'The user might want to shutdown, lets show him the dialog
        SHShutDownDialog 0
    Case "!setcolor"
        'The user (or a module) wants to set a system colour
        If InStr(parameter, " ") = 0 Then
            oServer.Execute "!log error in command, the syntax is !setcolor [whatcolor] [hexvalue]"
        Else
            syscolor(0) = getcolor(left(parameter, InStr(parameter, " ") - 1))
            If syscolor(0) > -1 Then
                textline = right(parameter, Len(parameter) - InStr(parameter, " "))
                If Len(textline) <> 6 Then
                    oServer.Execute "!log error in command, the color value must be a six characters long hex value"
                Else
                    ColorValues(0) = RGB(CByte("&H" & left(textline, 2)), CByte("&H" & Mid(textline, 3, 2)), CByte("&H" & right(textline, 2)))
                    ret = SetSysColors(1, syscolor(0), ColorValues(0))
                End If
            Else
                oServer.Execute "!log error in command, there is no color setting named " & left(parameter, InStr(parameter, " ") - 1)
            End If
        End If
    Case "!unload"
        oServer.UnloadPlugin parameter
    Case "!load"
        If InStr(parameter, " ") > 0 Then
            command = left(parameter, InStr(parameter, " ") - 1)
            parameter = right(parameter, Len(parameter) - InStr(parameter, " "))
            oServer.LoadPlugin parameter, command
        Else
            oServer.LoadPlugin "", parameter
        End If
    Case "!about"
        frmAbout.Show
    Case "!reload"
        bReload = True
        bExit = True
    Case "!quit"
        bExit = True
    Case Else
        If left(command, 1) = "!" Then
            found = False
            For I = 0 To UBound(Bangs)
                If LCase(command) = LCase(Bangs(I).Name) Then
                    found = True
                    j = 0
                    While j < UBound(Plugins) And LCase(Plugins(j).Name) <> LCase(Bangs(I).provider)
                        j = j + 1
                    Wend
                    If LCase(Plugins(j).Name) = LCase(Bangs(I).provider) Then
                        If Not Plugins(j).oPlugin Is Nothing Then
                            Plugins(j).oPlugin.Bang LCase(command), parameter
                        End If
                    Else
                        oServer.Execute "!log There is no module loaded with the name " & Bangs(I).provider
                    End If
                End If
            Next I
            If LCase(command) = "!log" And Not found Then
                ReDim Log(UBound(Log) + 1)
                Log(UBound(Log)) = parameter
            End If
        Else
            RunFile noPath(textline), path(textline), SW_NORMAL
        End If
    End Select

End Sub
Public Function swapVirtual(what As String) As String

    'This is where core handles the virtual variables and other none explicit settings
    Dim textline As String
    Dim Name As String
    Dim StopIt As Boolean
    Dim hCurKey As Long
    Dim lngDataBufferSize As Long
    Dim lngValueType As Long
    Dim strBuffer As String
    Dim sPath As String
    Dim hwnd As Long
    Dim module As String
    Dim key As String
    Dim attr As String
    Dim I As Long
    Dim r As RECT
    Dim colorValue As Long

    hwnd = GetDesktopWindow()
    
    StopIt = False
    textline = what
    While InStr(textline, "$") And Not StopIt
        Name = right(textline, Len(textline) - InStr(textline, "$"))
        If InStr(Name, "$") Then
            Name = left(Name, InStr(Name, "$") - 1)
            If InStr(Name, ".") Then
                'We have a internal link to another section, lets resolve it
                module = left(Name, InStr(Name, ".") - 1)
                key = right(Name, Len(Name) - InStr(Name, "."))
                oServer.Execute "!log module=" & module & " key=" & key
                If InStr(key, ".") Then
                    'We are refering to a property of the running plugin, lets find out which.
                    attr = right(key, Len(key) - InStr(key, "."))
                    key = left(key, InStr(key, ".") - 1)
                    oServer.Execute "!log attr=" & attr & " key=" & key
                    If LCase(key) = "window" Then
                        'We want a attribute of the plugin window
                        For I = 0 To UBound(Plugins)
                            If LCase(module) = LCase(Plugins(I).Name) Then
                                GetWindowRect Plugins(I).hwnd, r
                                Select Case LCase(attr)
                                Case "x"
                                    textline = Replace(textline, "$" & Name & "$", r.left)
                                Case "y"
                                    textline = Replace(textline, "$" & Name & "$", r.top)
                                Case "width"
                                    textline = Replace(textline, "$" & Name & "$", r.right - r.left)
                                Case "height"
                                    textline = Replace(textline, "$" & Name & "$", r.bottom - r.top)
                                End Select
                            End If
                        Next I
                    End If
                Else
                    'Get the desired value from the given modules section
                    textline = Replace(textline, "$" & Name & "$", oSettings.GetKey(module, key))
                End If
            Else
                'Its a ordinary virtual variable, either a system variable or one choosen by the user
                Select Case LCase(Name)
                Case "programs"
                    If fGetSystemFolderPath(hwnd, CSIDL_PROGRAMS, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "personal"
                    If fGetSystemFolderPath(hwnd, CSIDL_PERSONAL, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "favorites"
                    If fGetSystemFolderPath(hwnd, CSIDL_FAVORITES, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "startup"
                    If fGetSystemFolderPath(hwnd, CSIDL_STARTUP, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "recent"
                    If fGetSystemFolderPath(hwnd, CSIDL_RECENT, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "sendto"
                    If fGetSystemFolderPath(hwnd, CSIDL_SENDTO, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "nethood"
                    If fGetSystemFolderPath(hwnd, CSIDL_NETHOOD, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "fonts"
                    If fGetSystemFolderPath(hwnd, CSIDL_FONTS, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "templates"
                    If fGetSystemFolderPath(hwnd, CSIDL_TEMPLATES, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "common_startmenu"
                    If fGetSystemFolderPath(hwnd, CSIDL_COMMON_STARTMENU, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "common_programs"
                    If fGetSystemFolderPath(hwnd, CSIDL_COMMON_PROGRAMS, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "common_startup"
                    If fGetSystemFolderPath(hwnd, CSIDL_COMMON_STARTUP, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "common_desktopdirectory"
                    If fGetSystemFolderPath(hwnd, CSIDL_COMMON_DESKTOPDIRECTORY, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "desktopdirectory"
                    If fGetSystemFolderPath(hwnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "appdata"
                    If fGetSystemFolderPath(hwnd, CSIDL_APPDATA, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "printhood"
                    If fGetSystemFolderPath(hwnd, CSIDL_PRINTHOOD, sPath) Then
                        textline = Replace(textline, "$" & Name & "$", sPath)
                    End If
                Case "screenheight"
                    textline = Replace(textline, "$" & Name & "$", Screen.Height / Screen.TwipsPerPixelY)
                Case "screenwidth"
                    textline = Replace(textline, "$" & Name & "$", Screen.Width / Screen.TwipsPerPixelX)
                Case "corepath"
                    textline = Replace(textline, "$" & Name & "$", App.path)
                Case Else
                    ' Could it be a system color that the user wants to use?
                    colorValue = getcolor(Name)
                    If colorValue > -1 Then
                        ' yes it was, get the system color
                        textline = Replace(textline, "$" & Name & "$", GetSysColor(colorValue))
                    Else
                        ' nope, its just a ordinary userdefined variable
                        textline = Replace(textline, "$" & Name & "$", oSettings.GetKey("core", Name))
                    End If
                End Select
            End If
        Else
            StopIt = True
        End If
    Wend
    swapVirtual = textline

End Function
Public Function addcolor(Name As String, Value As String)

    ReDim Preserve SysColors(UBound(SysColors) + 1)
    
    SysColors(UBound(SysColors)).Name = Name
    SysColors(UBound(SysColors)).Value = Value

End Function
Public Function getcolor(Name As String) As Long

    Dim I As Long
    
    I = 0
    If UBound(SysColors) > 0 Then
        While I <= UBound(SysColors) And LCase(SysColors(I).Name) <> LCase(Name)
            I = I + 1
        Wend
        If LCase(SysColors(I).Name) = LCase(Name) Then
            getcolor = SysColors(I).Value
        Else
            getcolor = -1
        End If
    Else
        getcolor = -1
    End If

End Function
Public Sub SetupSystemColors()

    Dim textline As String
    Dim I As Long
    Dim ret As Long

    addcolor LCase("SC3DDkShadow"), 21                  ' Dark shadow for three-dimensional display elements.
    addcolor LCase("SC3DFace"), 15                      ' Face color for three-dimensional display elements and for dialog box backgrounds.
    addcolor LCase("SCBtnFace"), 15
    addcolor LCase("SC3DHiLight"), 20                   ' Highlight color for three-dimensional display elements (for edges facing the light source.)
    addcolor LCase("SC3DHighLight"), 20
    addcolor LCase("SCBtnHiLight"), 20
    addcolor LCase("SCBtnHighLight"), 20
    addcolor LCase("SC3DLight"), 22                     ' Light color for three-dimensional display elements (for edges facing the light source.)
    addcolor LCase("SC3DShadow"), 16                    ' Shadow color for three-dimensional display elements (for edges facing away from the light source).
    addcolor LCase("SCBtnShadow"), 16
    addcolor LCase("SCActiveBorder"), 10                ' Active window border.
    addcolor LCase("SCActiveCaption"), 2                ' Active window title bar.  Windows 98, Windows 2000: Specifies the left side color in the
                                                        ' color gradient of an active window's title bar if the gradient effect is enabled.
    addcolor LCase("SCAppWorkSpace"), 12                ' Background color of multiple document interface (MDI) applications.
    addcolor LCase("SCBackground"), 1                   ' Desktop.
    addcolor LCase("SCDesktop"), 1
    addcolor LCase("SCBtnText"), 18                     ' Text on push buttons.
    addcolor LCase("SCCaptionText"), 9                  ' Text in caption, size box, and scroll bar arrow box.
    addcolor LCase("SCGradientActiveCaption"), 27       ' Windows 98, Windows 2000: Right side color in the color gradient of an active window's
                                                        ' title bar. cActiveCaption specifies the left side color. Use SPI_GETGRADIENTCaptionS
                                                        ' with the SystemParametersInfo <sysinfo_4p67.htm> function to determine whether the gradient
                                                        ' effect is enabled.
    addcolor LCase("SCGradientInactiveCaption"), 28     ' Windows 98, Windows 2000: Right side color in the color gradient of an inactive window's
                                                        ' title bar. cInactiveCaption specifies the left side color.

    addcolor LCase("SCGrayText"), 17                    ' Grayed (disabled) text. This color is set to 0 if the current display driver does not
                                                        ' support a solid gray color.
    addcolor LCase("SCHighLight"), 13                   ' Item(s) selected in a control.
    addcolor LCase("SCHighLightText"), 14               ' Text of item(s) selected in a control.
    addcolor LCase("SCInactiveBorder"), 11              ' Inactive window border.
    addcolor LCase("SCInactiveCaption"), 3              ' Inactive window caption.  Windows 98, Windows 2000: Specifies the left side color in the
                                                        ' color gradient of an inactive window's title bar if the gradient effect is enabled.
    addcolor LCase("SCInactiveCaptionText"), 19         ' Color of text in an inactive caption.
    addcolor LCase("SCInfoBk"), 24                      ' Background color for tooltip controls.
    addcolor LCase("SCInfoText"), 23                    ' Text color for tooltip controls.
    addcolor LCase("SCMenu"), 4                         ' Menu background.
    addcolor LCase("SCMenuText"), 7                     ' Text in menus.
    addcolor LCase("SCScrollBar"), 0                    ' Scroll bar gray area.
    addcolor LCase("SCWindow"), 5                       ' Window background.
    addcolor LCase("SCWindowFrame"), 6                  ' Window frame.
    addcolor LCase("SCWindowText"), 8                   ' Text in windows.

    ReDim syscolor(0)
    ReDim ColorValues(0)
    ReDim OldColor(0)
    
    For I = 1 To UBound(SysColors)
        ReDim Preserve syscolor(UBound(syscolor) + 1)
        ReDim Preserve ColorValues(UBound(ColorValues) + 1)
        ReDim Preserve OldColor(UBound(OldColor) + 1)
        
        textline = oServer.GetKey("theme", SysColors(I).Name)
        If textline <> "" Then
            If Len(textline) <> 6 Then
                oServer.Execute "!log error reading the color settings for " & SysColors(I).Name
            Else
                syscolor(UBound(syscolor)) = SysColors(I).Value
                ColorValues(UBound(ColorValues)) = RGB(CByte("&H" & left(textline, 2)), CByte("&H" & Mid(textline, 3, 2)), CByte("&H" & right(textline, 2)))
                OldColor(UBound(OldColor)) = GetSysColor(SysColors(I).Value)
            End If
        End If
    Next
    ret = SetSysColors(UBound(syscolor), syscolor(0), ColorValues(0))

End Sub
Public Sub RestoreColors()

    Dim ret As Long
    
    ret = SetSysColors(UBound(SysColors), syscolor(0), OldColor(0))
    
End Sub
